commit e495fbb4f2dbc2f1a8d5f68c78c64845265c731d
Author: freddy77 <freddy77>
Date:   Fri Nov 27 16:16:38 2009 +0000

    Fix SQLGetData from fixed to CHAR not returning always SQL_SUCCESS

diff --git a/ChangeLog b/ChangeLog
index 2ddd0d8..86b932a 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Fri Nov 27 17:15:36 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/odbc/unittests/getdata.c:
+	- Fix SQLGetData from fixed to CHAR not returning always
+	  SQL_SUCCESS
+
 Thu Nov 26 10:46:01 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/ctlib.h include/tds.h src/ctlib/ct.c src/tds/config.c:
 	* src/tds/login.c src/tds/mem.c:
@@ -1917,4 +1922,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2889 2009/11/26 09:47:40 freddy77 Exp $
+$Id: ChangeLog,v 1.2890 2009/11/27 16:16:38 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index ed72926..708416e 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.515 2009/11/19 08:45:49 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.516 2009/11/27 16:16:39 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -4732,7 +4732,7 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 				ODBC_RETURN(stmt, SQL_SUCCESS_WITH_INFO);
 			}
 		} else {
-			colinfo->column_text_sqlgetdatapos = colinfo->column_size;
+			colinfo->column_text_sqlgetdatapos = colinfo->column_cur_size;
 		}
 	}
 	ODBC_RETURN_(stmt);
diff --git a/src/odbc/unittests/getdata.c b/src/odbc/unittests/getdata.c
index 76f169f..f67701c 100644
--- a/src/odbc/unittests/getdata.c
+++ b/src/odbc/unittests/getdata.c
@@ -1,7 +1,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: getdata.c,v 1.10 2008/11/04 14:46:17 freddy77 Exp $";
+static char software_version[] = "$Id: getdata.c,v 1.11 2009/11/27 16:16:39 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char odbc_err[256];
@@ -64,7 +64,7 @@ mycmp(const char *s1, const char *s2)
 int
 main(int argc, char *argv[])
 {
-	char buf[16];
+	char buf[32];
 	SQLINTEGER int_buf;
 	SQLLEN len;
 
@@ -142,19 +142,42 @@ main(int argc, char *argv[])
 
 	ResetStatement();
 
+	/* test with numeric */
+	Command("SELECT CONVERT(NUMERIC(18,5), 1850000000000)");
+
+	CHKFetch("S");
+
+	memset(buf, 'x', sizeof(buf));
+	CHKGetData(1, SQL_C_CHAR, buf, 14, NULL, "S");
+	buf[sizeof(buf)-1] = 0;
+	if (strcmp(buf, "1850000000000") != 0) {
+		printf("Wrong data result: %s\n", buf);
+		exit(1);
+	}
+
+	/* should give NO DATA */
+	CHKGetData(1, SQL_C_CHAR, buf, 14, NULL, "No");
+	buf[sizeof(buf)-1] = 0;
+	if (strcmp(buf, "1850000000000") != 0) {
+		printf("Wrong data result 3 res = %s\n", buf);
+		exit(1);
+	}
+
+	ResetStatement();
+
 	Disconnect();
 
 	use_odbc_version3 = 1;
 	Connect();
 
 	/* test error from SQLGetData */
-	/* wrong constant */
+	/* wrong constant, SQL_VARCHAR is invalid as C type */
 	test_err("prova 123",           SQL_VARCHAR,     "HY003");
 	/* use ARD but no ARD data column */
 	test_err("prova 123",           SQL_ARD_TYPE,    "07009");
 	/* wrong conversion, int */
 	test_err("prova 123",           SQL_C_LONG,      "22018");
-	/* wrong conversion, int */
+	/* wrong conversion, date */
 	test_err("prova 123",           SQL_C_TIMESTAMP, "22018");
 	/* overflow */
 	test_err("1234567890123456789", SQL_C_LONG,      "22003");

